#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv/usbdrv.h"

#define F_CPU 16000000L
#define VENDOR_RQ_GET_SWITCH  1

uint8_t in_c(uint8_t pin)
{
	DDRC &= ~(1<<pin);
	PORTC |= (1<<pin);
	return ((PINC & (1<<pin))>>pin);
}

int main()
{
	DDRC  |= 0b00000111;
	PORTC = 0b00000000;
	PORTC |= (1 << 3);
	DDRD  &= ~(0b00001000);
	PORTD = 0b00000000;
	usbInit();
	usbDeviceDisconnect();
	_delay_ms(300);     /* fake USB disconnect for > 250 ms */
	usbDeviceConnect();
	sei();              /* enable interrupts */
	while (1)           /* main event loop */
	{                
	   usbPoll();      /* คำสั่งนี้ต้องถูกเรียกอย่างน้อยที่สุดทุก ๆ 50ms */
	}
	return 0;
}

uint16_t read_adc(uint8_t channel)
{
        ADMUX = 0b01000000;
        ADMUX |= channel;
        ADCSRA = 0b11000110;
        while((ADCSRA & (1<<ADSC)))
                ;
        return ADCL + ADCH*256;

}

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
	usbRequest_t *rq = (void *)data;
	static uchar dataBuffer[2];  /* ข้อมูลนี้ต้องไม่ถูกเขียนทับหลังจาก usbFunctionSetup รีเทิร์น */
    /* ประมวลผลตามหมายเลขคำสั่งที่อยู่ใน bRequest */
	if (rq->bRequest == VENDOR_RQ_GET_SWITCH)
	{
		dataBuffer[0] = !in_c(3);
		usbMsgPtr = dataBuffer;
		return 1;
	}
	return 0;   /* ไม่รู้จักคำร้องขอ ไม่ส่งข้อมูลกลับ */
}


